VERSION 5.00
Begin VB.Form FrmCollisions 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Collisions Demo"
   ClientHeight    =   4395
   ClientLeft      =   2415
   ClientTop       =   1710
   ClientWidth     =   5115
   Icon            =   "FrmCollisions.frx":0000
   MaxButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   293
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   341
   Begin VB.CommandButton CmdToggle 
      Caption         =   "&Run"
      Height          =   375
      Left            =   4020
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   3900
      Width           =   975
   End
   Begin VB.PictureBox PicDisplay 
      BackColor       =   &H00000000&
      ClipControls    =   0   'False
      ForeColor       =   &H00000000&
      Height          =   3660
      Left            =   120
      LinkTimeout     =   0
      ScaleHeight     =   240
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   320
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   120
      Width           =   4860
   End
   Begin VB.PictureBox PicBall 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ClipControls    =   0   'False
      ForeColor       =   &H00000000&
      Height          =   315
      Left            =   5220
      LinkTimeout     =   0
      Picture         =   "FrmCollisions.frx":000C
      ScaleHeight     =   21
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   42
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   3840
      Visible         =   0   'False
      Width           =   630
   End
   Begin VB.PictureBox PicBB 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ClipControls    =   0   'False
      ForeColor       =   &H00000000&
      Height          =   3600
      Left            =   5160
      LinkTimeout     =   0
      Picture         =   "FrmCollisions.frx":0ACE
      ScaleHeight     =   240
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   320
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   120
      Visible         =   0   'False
      Width           =   4800
   End
End
Attribute VB_Name = "FrmCollisions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' =========================================
' Author:    Stuart Pennington.
' Location:  Preston, Lancashire, England.
' E-Mail:    vbthing@hotmail.com
'
' Project:   Colliding With Static Objects.
' Completed: Thursday 8th February 2001.
' Platform:  Windows 98 SE.
' Processor: Pentium 11 - 300Mz.
' =========================================



Private Cx!, Cy!                ' Vertical And Horizontal Centre Of The Orb.
Private Dx%, Dy%                ' Vertical And Horizontal Movement Of The Orb.
Private bQuitLoop As Boolean    ' Quit Loop Indicator.

Private W%, H%                  ' ScaleWidth And ScaleHeight Of Back Buffer.

' Good API Call's...
Private Declare Function BitBlt& Lib "gdi32" (ByVal hDestDC&, ByVal x1&, ByVal y1&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDc&, ByVal xSrc&, ByVal ySrc&, ByVal dwRop&)
Private Declare Function GetPixel& Lib "gdi32" (ByVal ahDc&, ByVal x1&, ByVal y1&)
Private Declare Function timeGetTime& Lib "winmm.dll" ()

' App Defined Constant's...
Private Const RADIUS = 10
Private Const PI As Single = 3.14159265358979
Private Const TWO_PI As Single = 6.28318530717959
Private Const PI_DIV_2 As Single = 1.5707963267949
Private Const THREE_PI_DIV_2 As Single = 4.71238898038469
Private Const PI_DIV_45 As Single = 6.98131700797732E-02
Private Sub Form_Load()

    ' Seed Random Number Generator For Initialization's.
    Randomize

    ' Transfer These To Variables For Loop Optimization.
    W = PicBB.ScaleWidth - 1
    H = PicBB.ScaleHeight - 1

    ' Position The Form On The Screen.
    Move (Screen.Width - Width) \ 2, (Screen.Height - Height) \ 3

End Sub
Private Sub PositionBall()

    Dim K!                        ' Counter.
    Dim bBadPosition As Boolean   ' Indicates That The Positioning Of The Orb Overlaps A Block.

    ' Going To Give The "Orb" A Random Position On The Back Buffer,
    ' But It Must Not Be Placed On A Block Or Partially Off The Form.

    Do
      DoEvents
      ' Find A Valid Centre Position For The Orb
      ' Within The Confines Of The Back Buffer.
      Cx = Int(((W - RADIUS) - RADIUS + 1) * Rnd + RADIUS)
      Cy = Int(((H - RADIUS) - RADIUS + 1) * Rnd + RADIUS)
      ' Set The Indicator Of "Bad Placement" To False.
      bBadPosition = False
      ' Scan the "Outer" Perimeter Of The Orb To See If We Are
      ' Overlapping A Block.
      ' Need To Use "RADIUS + 2" Because I Want To Scan "One" Pixel Outside
      ' The Radius. The Radius = 10 + The Centre-Pixel It Is Based On + 1
      ' To Take Us Outside The Circumference/Orb-Perimeter.
      ' Confused, Get VB To Draw A Cicle Of Radius Ten.
      ' Print Screen And Measure It Under Magnification In MS Paint.
      ' It's Diameter Will Be 21. (2 * 10 + 1)
      For K = 0 To TWO_PI Step PI_DIV_45
          ' The Floor Of The "Room" Is Black.
          If GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(K) + Cx, (RADIUS + 2) * Cos(K) + Cy) <> 0 Then
             ' Found A Non-Black Color... Try Again.
             bBadPosition = True
             Exit For
          End If
      Next
    Loop Until bBadPosition = False

    ' Blit The Orb (Mask Then Image) Onto The Back Buffer.
    BitBlt PicBB.hDC, Cx - RADIUS, Cy - RADIUS, 21, 21, PicBall.hDC, 0, 0, vbSrcAnd
    BitBlt PicBB.hDC, Cx - RADIUS, Cy - RADIUS, 21, 21, PicBall.hDC, 21, 0, vbSrcInvert

    ' We Are Ready.

End Sub
Private Sub SetDirection()

    ' Purpose: Set's Random Value's For The X, Y Movement Of The Orb.

    Do
      DoEvents
      Dx = Sgn(Rnd - Rnd)
      Dy = Sgn(Rnd - Rnd)
    Loop Until Not (Dx = 0 And Dy = 0)

    If Dx < 0 Then Dx = Dx - Rnd Else Dx = Dx + Rnd
    If Dy < 0 Then Dy = Dy - Rnd Else Dy = Dy + Rnd

End Sub
Private Sub CmdToggle_Click()

    ' Purpose: Start's A Fresh Animation Or Stop's The One In Progress.

    If CmdToggle.Caption = "&Run" Then
       CmdToggle.Caption = "&Stop"
       bQuitLoop = False
       PositionBall
       SetDirection
       DoEvents
       RunLoop
    Else
       CmdToggle.Caption = "&Run"
       bQuitLoop = True
       DoEvents
       PicDisplay.Cls
    End If

End Sub
Private Sub RunLoop()

    Dim K!  ' Copunter.
    Dim T&  ' For Timed Loop.

    Do
      ' Initial Parameters Have Been Established, So Show The User The Situation.
      BitBlt PicDisplay.hDC, 0, 0, 320, 240, PicBB.hDC, 0, 0, vbSrcCopy
      ' Clear The Back Buffer.
      ' The Picture Of The Blocks Are A Permanent Graphic, So They Will Stay.
      PicBB.Cls
      DoEvents

      ' Simple Stuff To Make Sure The Orb Stays On The Form.
      If Cx + RADIUS >= W Then Dx = -Dx
      If Cx - RADIUS <= 0 Then Dx = -Dx
      If Cy + RADIUS >= H Then Dy = -Dy
      If Cy - RADIUS <= 0 Then Dy = -Dy
         
      ' Hectic Stuff...
      ' Colliding With Object's In The "Room".
      If Dx > 0 And Dy > 0 Then
         ' =============================================
         ' Orb Is Travelling To The Right And Downwards.
         ' =============================================
         If GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(0) + Cx, (RADIUS + 2) * Cos(0) + Cy) > 0 Then
            ' Bottom Of The Orb Has Collided With A Block.
            Dy = -Dy
         ElseIf GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(PI_DIV_2) + Cx, (RADIUS + 2) * Cos(PI_DIV_2) + Cy) > 0 Then
            ' Right Side Of Orb Has Collided With A Block.
            Dx = -Dx
         Else
            ' Scan The Lower Right Hand Quadrant Perimeter Of The Orb.
            For K = 0 To PI_DIV_2 Step PI_DIV_45
                If GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(K) + Cx, (RADIUS + 2) * Cos(K) + Cy) > 0 Then
                   ' Hit The Corner Of A Block, Total Rebound.
                   Dx = -Dx
                   Dy = -Dy
                   Exit For
                End If
            Next
         End If
      ElseIf Dx > 0 And Dy < 0 Then
         ' ===========================================
         ' Orb Is Travelling To The Right And Upwards.
         ' ===========================================
         If GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(PI_DIV_2) + Cx, (RADIUS + 2) * Cos(PI_DIV_2) + Cy) > 0 Then
            ' Right Side Of Orb Has Collided With A Block.
            Dx = -Dx
         ElseIf GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(PI) + Cx, (RADIUS + 2) * Cos(PI) + Cy) > 0 Then
            ' Top Of Orb Has Collided With A Block.
            Dy = -Dy
         Else
            ' Scan The Upper Right Hand Quadrant Perimeter Of The Orb.
            For K = PI_DIV_2 To PI Step PI_DIV_45
                If GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(K) + Cx, (RADIUS + 2) * Cos(K) + Cy) > 0 Then
                   ' Hit The Corner Of A Block, Total Rebound.
                   Dx = -Dx
                   Dy = -Dy
                   Exit For
                End If
            Next
         End If
      ElseIf Dx < 0 And Dy > 0 Then
         ' ============================================
         ' Orb Is Travelling To The Left And Downwards.
         ' ============================================
         If GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(THREE_PI_DIV_2) + Cx, (RADIUS + 2) * Cos(THREE_PI_DIV_2) + Cy) > 0 Then
            ' Left Side Of Orb Has Collided With A Block.
            Dx = -Dx
         ElseIf GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(TWO_PI) + Cx, (RADIUS + 2) * Cos(TWO_PI) + Cy) > 0 Then
            ' Bottom Of Orb Has Collided With A Block.
            Dy = -Dy
         Else
            ' Scan The Lower Left Hand Quadrant Perimeter Of The Orb.
            For K = THREE_PI_DIV_2 To TWO_PI Step PI_DIV_45
                If GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(K) + Cx, (RADIUS + 2) * Cos(K) + Cy) > 0 Then
                   ' Hit The Corner Of A Block, Total Rebound.
                   Dx = -Dx
                   Dy = -Dy
                   Exit For
                End If
            Next
         End If
      Else
         ' ==========================================
         ' Orb Is Travelling To The Left And Upwards.
         ' ==========================================
         If GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(PI) + Cx, (RADIUS + 2) * Cos(PI) + Cy) > 0 Then
            ' Top Of Orb Has Collided With A Block.
            Dy = -Dy
         ElseIf GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(THREE_PI_DIV_2) + Cx, (RADIUS + 2) * Cos(THREE_PI_DIV_2) + Cy) > 0 Then
            ' Left Hand Side Of Orb Has Collided With A Block.
            Dx = -Dx
         Else
            ' Scan The Upper Left Hand Quadrant Perimeter Of The Orb.
            For K = PI To THREE_PI_DIV_2 Step PI_DIV_45
                If GetPixel(PicBB.hDC, (RADIUS + 2) * Sin(K) + Cx, (RADIUS + 2) * Cos(K) + Cy) > 0 Then
                   ' Hit The Corner Of A Block, Total Rebound.
                   Dx = -Dx
                   Dy = -Dy
                   Exit For
                End If
            Next
         End If
      End If

      ' Apply The Movement.
      Cx = Cx + Dx
      Cy = Cy + Dy

      ' Update The Back Buffer.
      BitBlt PicBB.hDC, Cx - RADIUS, Cy - RADIUS, 21, 21, PicBall.hDC, 0, 0, vbSrcAnd
      BitBlt PicBB.hDC, Cx - RADIUS, Cy - RADIUS, 21, 21, PicBall.hDC, 21, 0, vbSrcInvert
    
      ' Home Made Timer.
      T = timeGetTime()
      Do
        DoEvents
      Loop Until (timeGetTime() - T >= 1) Or bQuitLoop
    Loop Until bQuitLoop

End Sub
Private Sub Form_Unload(Cancel%)

    End

End Sub
